<html>
<head>
<title>OgreFileSystem.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreFileSystem.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreFileSystem_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __FileSystem_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __FileSystem_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreArchive_8h.html">OgreArchive.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreArchiveFactory_8h.html">OgreArchiveFactory.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>Ogre {
<a name="l00037"></a>00037 
<a name="l00047"></a><a class="code" href="classOgre_1_1FileSystemArchive.html">00047</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1FileSystemArchive.html" title="Specialisation of the Archive class to allow reading of files from filesystem folders / directories...">FileSystemArchive</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Archive.html" title="Archive-handling class.">Archive</a> 
<a name="l00048"></a>00048     {
<a name="l00049"></a>00049     <span class="keyword">protected</span>:
<a name="l00060"></a>00060         <span class="keywordtype">void</span> findFiles(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; pattern, <span class="keywordtype">bool</span> recursive, <span class="keywordtype">bool</span> dirs,
<a name="l00061"></a>00061             <a class="code" href="group__General.html#ga0899c03496d3c25c6555889aa76a78db">StringVector</a>* simpleList, <a class="code" href="group__Resources.html#ga80f17ac4d148a831fe015742d56727f9">FileInfoList</a>* detailList) <span class="keyword">const</span>;
<a name="l00062"></a>00062 
<a name="l00063"></a>00063         <a class="code" href="OgrePrerequisites_8h.html#a18a523fad1f9e10324e1742865f562b7">OGRE_AUTO_MUTEX</a>
<a name="l00064"></a>00064     <span class="keyword">public</span>:
<a name="l00065"></a>00065         <a class="code" href="classOgre_1_1FileSystemArchive.html" title="Specialisation of the Archive class to allow reading of files from filesystem folders / directories...">FileSystemArchive</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; archType );
<a name="l00066"></a>00066         ~<a class="code" href="classOgre_1_1FileSystemArchive.html" title="Specialisation of the Archive class to allow reading of files from filesystem folders / directories...">FileSystemArchive</a>();
<a name="l00067"></a>00067 
<a name="l00069"></a>00069         <span class="keywordtype">bool</span> isCaseSensitive(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00070"></a>00070 
<a name="l00072"></a>00072         <span class="keywordtype">void</span> load();
<a name="l00074"></a>00074         <span class="keywordtype">void</span> unload();
<a name="l00075"></a>00075 
<a name="l00077"></a>00077         <a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a> open(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; filename, <span class="keywordtype">bool</span> readOnly = <span class="keyword">true</span>) <span class="keyword">const</span>;
<a name="l00078"></a>00078 
<a name="l00080"></a>00080         <a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a> create(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; filename) <span class="keyword">const</span>;
<a name="l00081"></a>00081 
<a name="l00083"></a>00083         <span class="keywordtype">void</span> <span class="keyword">remove</span>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; filename) <span class="keyword">const</span>;
<a name="l00084"></a>00084 
<a name="l00086"></a>00086         <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">StringVectorPtr</a> <a class="code" href="structOgre_1_1list.html">list</a>(<span class="keywordtype">bool</span> recursive = <span class="keyword">true</span>, <span class="keywordtype">bool</span> dirs = <span class="keyword">false</span>);
<a name="l00087"></a>00087 
<a name="l00089"></a>00089         <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">FileInfoListPtr</a> listFileInfo(<span class="keywordtype">bool</span> recursive = <span class="keyword">true</span>, <span class="keywordtype">bool</span> dirs = <span class="keyword">false</span>);
<a name="l00090"></a>00090 
<a name="l00092"></a>00092         <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">StringVectorPtr</a> find(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; pattern, <span class="keywordtype">bool</span> recursive = <span class="keyword">true</span>,
<a name="l00093"></a>00093             <span class="keywordtype">bool</span> dirs = <span class="keyword">false</span>);
<a name="l00094"></a>00094 
<a name="l00096"></a>00096         <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">FileInfoListPtr</a> findFileInfo(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; pattern, <span class="keywordtype">bool</span> recursive = <span class="keyword">true</span>,
<a name="l00097"></a>00097             <span class="keywordtype">bool</span> dirs = <span class="keyword">false</span>) <span class="keyword">const</span>;
<a name="l00098"></a>00098 
<a name="l00100"></a>00100         <span class="keywordtype">bool</span> exists(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; filename);
<a name="l00101"></a>00101 
<a name="l00103"></a>00103         time_t getModifiedTime(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; filename);
<a name="l00104"></a>00104 
<a name="l00108"></a><a class="code" href="classOgre_1_1FileSystemArchive.html#ae1e6d89d5edc833b8ea5ef74d32a5ad1">00108</a>         <span class="keyword">static</span> <span class="keywordtype">void</span> setIgnoreHidden(<span class="keywordtype">bool</span> ignore)
<a name="l00109"></a>00109         {
<a name="l00110"></a>00110             msIgnoreHidden = ignore;
<a name="l00111"></a>00111         }
<a name="l00112"></a>00112 
<a name="l00114"></a><a class="code" href="classOgre_1_1FileSystemArchive.html#a79c4957064dc9858d3abdc87ebadfe7c">00114</a>         <span class="keyword">static</span> <span class="keywordtype">bool</span> getIgnoreHidden()
<a name="l00115"></a>00115         {
<a name="l00116"></a>00116             <span class="keywordflow">return</span> msIgnoreHidden;
<a name="l00117"></a>00117         }
<a name="l00118"></a>00118 
<a name="l00119"></a><a class="code" href="classOgre_1_1FileSystemArchive.html#a197c16fb380d5d245f27ede38eadcb5a">00119</a>         <span class="keyword">static</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1FileSystemArchive.html#a197c16fb380d5d245f27ede38eadcb5a">msIgnoreHidden</a>;
<a name="l00120"></a>00120     };
<a name="l00121"></a>00121 
<a name="l00123"></a>00123     <span class="comment">//class _OgrePrivate FileSystemArchiveFactory : public ArchiveFactory</span>
<a name="l00124"></a><a class="code" href="classOgre_1_1FileSystemArchiveFactory.html">00124</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1FileSystemArchiveFactory.html" title="Specialisation of ArchiveFactory for FileSystem files.">FileSystemArchiveFactory</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ArchiveFactory.html" title="Abstract factory class, archive codec plugins can register concrete subclasses of this...">ArchiveFactory</a>
<a name="l00125"></a>00125     {
<a name="l00126"></a>00126     <span class="keyword">public</span>:
<a name="l00127"></a><a class="code" href="classOgre_1_1FileSystemArchiveFactory.html#a375c0b982fa94bedec0c07309158c80a">00127</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1FileSystemArchiveFactory.html#a375c0b982fa94bedec0c07309158c80a">~FileSystemArchiveFactory</a>() {}
<a name="l00129"></a>00129         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getType(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00131"></a><a class="code" href="classOgre_1_1FileSystemArchiveFactory.html#a1495b7d2570e2076059bbf42e751f072">00131</a>         <a class="code" href="classOgre_1_1Archive.html" title="Archive-handling class.">Archive</a> *createInstance( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name ) 
<a name="l00132"></a>00132         {
<a name="l00133"></a>00133             <span class="keywordflow">return</span> <a class="code" href="group__Memory.html#gab5fc1358fd5a889de0a06d07e45df1ff">OGRE_NEW</a> <a class="code" href="classOgre_1_1FileSystemArchive.html" title="Specialisation of the Archive class to allow reading of files from filesystem folders / directories...">FileSystemArchive</a>(name, <span class="stringliteral">&quot;FileSystem&quot;</span>);
<a name="l00134"></a>00134         }
<a name="l00136"></a><a class="code" href="classOgre_1_1FileSystemArchiveFactory.html#ab5db375993d3e50c6edd47a4525d1502">00136</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1FileSystemArchiveFactory.html#ab5db375993d3e50c6edd47a4525d1502">destroyInstance</a>( <a class="code" href="classOgre_1_1Archive.html" title="Archive-handling class.">Archive</a>* arch) { <span class="keyword">delete</span> arch; }
<a name="l00137"></a>00137     };
<a name="l00138"></a>00138 
<a name="l00142"></a>00142 }
<a name="l00143"></a>00143 
<a name="l00144"></a>00144 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
